// ---- RECEIVER ----
#include <Arduino.h>

const int led =  4;           // Pin of the led ( also MOSI )
const int hallSensor = 8;     // Pin of the hall sensor
const int motor = 2;          // Pin of the motor
const int pot = A3;           // Pin of the Potentiometer

byte sendBuffer[6]={0,0,0,0,0,0};
byte receivedBuffer[2]={0,0};

void sendPosition(int distance,int angle);
void approchingSimulation();
void circleSimulation();
void updateParameters();


bool newOrder = false;        // New order available

void setup()
{
  // Configure the output pins
  pinMode(motor, OUTPUT);
  pinMode(led, OUTPUT);
  // Configure the input pins
  pinMode(hallSensor, INPUT_PULLUP);
  // Configure the serial link
  Serial.begin(9600);
  // Demarrage du moteur
  analogWrite(motor,255);
}

void loop()
{
  circleSimulation();
}

void updateParameters()
{
  if (Serial.available()>0)
  {
    byte c = Serial.read();
    analogWrite(motor,c);
  }
}

// Simulation of a robot turning around our robot
void circleSimulation()
{
  int iAngle = 0;
  while(iAngle<=360)
  {
    updateParameters();
    sendPosition(300,iAngle);
    iAngle+=5;
    delay(100);
  }
}

void sendPosition(int distance,int angle)
{
  digitalWrite(led,HIGH);
  sendBuffer[0]='b';              // Byte that begin the communication
	sendBuffer[1]=distance >> 8;
	sendBuffer[2]=distance & 255;
	sendBuffer[3]=angle >> 8;
	sendBuffer[4]=angle & 255;
  sendBuffer[5]='\n';             // Byte that end the communication

  for(int i=0;i<=5;i++)
	{
		Serial.write(sendBuffer[i]);
	}
  digitalWrite(led,LOW);
}
